﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Tests
{
    /* Contains a single column dimension caption and value from an MDX query */
    [Serializable()]
    public class CubeTuple : ISerializable
    {
        private String columnName;
        private Object columnValue;

        public CubeTuple(String columnName, Object columnValue)
        {
            this.columnName = columnName;
            this.columnValue = columnValue;
        }

        public CubeTuple(SerializationInfo info, StreamingContext context)
        {
            columnName = (string)info.GetValue("ColumnName", typeof(string));
            columnValue = info.GetValue("ColumnValue", typeof(object));
        }

        public String getColumnName() { return columnName; }

        public Object getColumnValue() { return columnValue; }

        #region ISerializable Members

        public void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            info.AddValue("ColumnName", columnName);
            info.AddValue("ColumnValue", columnValue);
        }

        #endregion
    }
}
