﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Tests
{
    [TestClass]
    public class PurchaseCubeTest : BaseMDXTest
    {
        public PurchaseCubeTest()
            : base("Data Source=devxrdb;Initial Catalog=PurchaseTest;", AppDomain.CurrentDomain.BaseDirectory)
        {            
        }

        [TestInitialize]
        public void InitializeCube()
        {
            XMLAtoCube xmlaToCube = new XMLAtoCube("c:\\CubeDefinition");
            string sourceServerName = "devxrdb";
            string targetServerName = "devxrdb";
            string sourceDatabaseName = "Purchase";
            string targetDatabaseName = "PurchaseTest";
            string targetDataSourceConnectionString = "Provider=SQLNCLI11.1;Data Source=DEVXRDB;Integrated Security=SSPI;Initial Catalog=sacdw_data_mark";
            xmlaToCube.CreateCubeFromXMLA(sourceServerName, targetServerName, sourceDatabaseName, targetDatabaseName, targetDataSourceConnectionString);
        }

        [TestMethod]
        public void TestPurchaseCubeSingleRowAndColumn()
        {
            // Query the number of items purchased by each customer regardless of time.
            string MDXQuerySingle = @"select {[Customer].[CustomerName].members} on 0,
	                                {[Item].[ItemName].members} on 1 
                                    from 
                                    [PurchaseCube]";
            bool result = TestMDXQuery("TestPurchaseCubeSingleRowAndColumn", MDXQuerySingle);
            Assert.IsTrue(result);
        }

        [TestMethod]
        public void TestPurchaseCubeMultipleRowsAndColumns()
        {
            // Query the number of items bought at each store location for each day of the year.
            string MDXQuerySingle = @"select {{EXCEPT([PurchaseDate].[Year].members,
                                                    [PurchaseDate].[Year].[All])}*
                                            {EXCEPT([PurchaseDate].[Month].members,
                                                    [PurchaseDate].[Month].[All])}*
                                            {EXCEPT([PurchaseDate].[Day].members,
                                                    [PurchaseDate].[Day].[All])}} on 0,
                                           {{EXCEPT([StoreLocation].[State].members,
                                                    [StoreLocation].[State].[All])}*
                                            {EXCEPT([Item].[ItemName].members,
                                                    [Item].[ItemName].[All])}} on 1
                                           from
                                           [PurchaseCube]";
            bool result = TestMDXQuery("TestPurchaseCubeMultipleRowsAndColumns", MDXQuerySingle);
            Assert.IsTrue(result);
        }
    }
}
